/*
 * (C) Copyright 2001
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * Misc functions
 */
#include <common.h>
#include <command.h>
#include <octeon_boot.h>

#if (CONFIG_COMMANDS & CFG_CMD_MISC)
extern ulong admin;
int do_sleep (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
   	if(admin==0){
		if (input_passwd()==1)
			return 1;}
	ulong delay;

	if (argc != 2) {
		printf ("Usage:\n%s\n", cmdtp->usage);
		return 1;
	}

	delay = simple_strtoul(argv[1], NULL, 10);

	while (delay) {
		int i;
		for (i=0; i<1000; ++i) {
			if (ctrlc ()) {
				return (-1);
			}
			udelay (1000);
		}
		--delay;
	}
	return 0;
}

int test_reset_button_cmd(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	if(admin==0){
		if (input_passwd()==1)
			return 1;}
	int i=0;

	printf("\nDetect Reset button");

	for(i=0; i < 1000; i++)
	{
	    	octeon_gpio_cfg_input(7);
		int G3;
		G3 = octeon_gpio_value(7);
		if( G3 ==1) 
		{
			//printf("1\n");
		}
		else if ( G3 == 0 ) 
		{
			printf("Success\n");
			return 0;
		}
		else
		{
			//printf("else\n");
		}
		
		//value = mvGppValueGet(0,RESET_BUTTON);
		/*
		if((value>>4)==1)
		{
			printf("Success\n");
			return 0;
		}
		*/

		if((i % 100)==0)
		printf(".");
		udelay(10000); // 10ms
 	}
	printf("Fail\n");
 
    	return 1;
}
int test_fan_cmd(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	if(admin==0){
		if (input_passwd()==1)
			return 1;}
	int i=0;
      
	printf("\nfan test ...\n");
	octeon_gpio_cfg_input(8);
       	for(i=0; i < 1000; i++)
	{
		int i=0;
	
		int G3;
		G3 = octeon_gpio_value(8);
		if( G3 ==1) 
		{
			printf("fan working ...\n");
			octeon_gpio_set(13); // set to high
			return 1;
		}
		else 
		{
			octeon_gpio_cfg_output(13);
			octeon_gpio_clr(13); // set to low
		}
		if((i % 100)==0)
		printf(".");
		udelay(10000); // 10ms
       	}
	printf("fan fail \n");	
}

int Wgpio (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	if(admin==0){
		if (input_passwd()==1)
			return 1;}
	ulong index,value;
	if (argc != 2) {
		printf ("Usage:\n%s\n", cmdtp->usage);
		return 1;
	}

	index = simple_strtoul(argv[1], NULL, 10);
	//value = simple_strtoul(argv[2], NULL, 10);

//	octeon_gpio_cfg_output(index);
	octeon_gpio_set(index);
	printf("Set GPIO %d .\n",index);

	return 0;
}

int Cgpio (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	if(admin==0){
		if (input_passwd()==1)
			return 1;}
	ulong index,value;

	if (argc != 2) {
		printf ("Usage:\n%s\n", cmdtp->usage);
		return 1;
	}

	index = simple_strtoul(argv[1], NULL, 10);
	//value = simple_strtoul(argv[2], NULL, 10);

//	octeon_gpio_cfg_output(index);
	octeon_gpio_clr(index);
	printf("Clr GPIO %d .\n",index);

	return 0;
}

int Rgpio (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	if(admin==0){
		if (input_passwd()==1)
			return 1;}
	ulong index;
	int value;

	if (argc != 2) {
		printf ("Usage:\n%s\n", cmdtp->usage);
		return 1;
	}
	index = simple_strtoul(argv[1], NULL, 10);
	//value = simple_strtoul(argv[2], NULL, 10);

//	octeon_gpio_cfg_input(index);
	value = octeon_gpio_value(index);

	printf("Read GPIO %d = %d .\n",index,value);

	return 0;
}

int do_testled (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	if(admin==0){
		if (input_passwd()==1)
			return 1;}
	if (argc >3) {
		printf ("Usage:\n%s\n", cmdtp->usage);
		return 1;
	}
	if(((strcmp(argv[2], "wan1_green") == 0) ||  (strcmp(argv[2], "wan2_green") == 0) 
	   ||(strcmp(argv[2], "wan1_amber") == 0) || (strcmp(argv[2], "wan2_amber") == 0) 
	   ||(strcmp(argv[2], "wan3_green") == 0) ||  (strcmp(argv[2], "wan4_green") == 0) 
	   ||(strcmp(argv[2], "wan3_amber") == 0) || (strcmp(argv[2], "wan4_amber") == 0)) 
	    && (strcmp(argv[1], "off") == 0) )
	{
		printf("ledtest off <test/DMZ/wan1/wan2/wan3/wan4>\n");
		return 0;
	} 
	if(((strcmp(argv[2], "wan1") == 0)  ||(strcmp(argv[2], "wan2") == 0) || ((strcmp(argv[2], "wan3") == 0)  ||(strcmp(argv[2], "wan4") == 0) ))
	    && (strcmp(argv[1], "on") == 0) )
	{
		printf("ledtest on <test/DMZ/wan1_green/wan1_amber/wan2_green/wan2_amber/wan3_green/wan3_amber/wan4_green/wan4_amber>\n");
		return 0;
	} 
	if (strcmp(argv[1],"off") == 0)
	{
		if(strcmp(argv[2],"test")==0)
		{
			octeon_gpio_set(13);
			printf("Turn off test led.\n");
		}
		else if(strcmp(argv[2],"wan1")==0)
		{
			octeon_gpio_set(9);
			octeon_gpio_set(14);
			printf("Turn off wan1 led.\n");
		}
		else if(strcmp(argv[2],"wan2")==0)
		{
			octeon_gpio_set(10);
			octeon_gpio_set(15);
			printf("Turn off wan2 led.\n");
		}
		else if(strcmp(argv[2],"wan3")==0)
		{		
			octeon_gpio_set(2);
			octeon_gpio_set(4);
			printf("Turn off wan3 led.\n");
		}
		else if(strcmp(argv[2],"wan4")==0)
		{	
			octeon_gpio_set(3);
			octeon_gpio_set(11);
			printf("Turn off wan4 led.\n");
		}				
		else if(strcmp(argv[2],"dmz")==0)
		{
			octeon_gpio_set(16);
			printf("Turn off dmz led.\n");
		}
		else if(strcmp(argv[2],"")==0)     /* turn off all leds */
		{
			octeon_gpio_set(13);
			
			octeon_gpio_set(9);
			octeon_gpio_set(14);

			octeon_gpio_set(10);
			octeon_gpio_set(15);

			octeon_gpio_set(2);
			octeon_gpio_set(4);
			
			octeon_gpio_set(3);
			octeon_gpio_set(11);			
			
			octeon_gpio_set(16);
			printf("Turn off all leds.\n");
		}
		else
		{
			printf("Invalid Parameter!\n");
			printf("ledtest off [test|wan1|wan2t|wan3|wan4|dmz]\n");
		       return 1;
		}
		return 0;
	}
	else if (strcmp(argv[1],"on") == 0)
	{	
	       	if(strcmp(argv[2],"test")==0)
		{
			octeon_gpio_cfg_output(13);
			octeon_gpio_clr(13);
			printf("Turn on test led.\n");
	       	}
		else if(strcmp(argv[2],"wan1_green")==0)
		{
			octeon_gpio_cfg_output(9);
			octeon_gpio_clr(9);
			octeon_gpio_cfg_output(14);
			octeon_gpio_set(14);
			printf("Turn on wan1_green led.\n");
		}
		else if(strcmp(argv[2],"wan1_amber")==0)
		{
			octeon_gpio_set(9);
			octeon_gpio_clr(14);
			printf("Turn on wan1_amber led.\n");
		}
		else if(strcmp(argv[2],"wan2_green")==0)
		{
			octeon_gpio_clr(10);
			octeon_gpio_set(15);
			printf("Turn on wan2_green led.\n");
		}
		else if(strcmp(argv[2],"wan2_amber")==0)
		{
			octeon_gpio_set(10);
			octeon_gpio_clr(15);
			printf("Turn on wan2_amber led.\n");
		}
		else if(strcmp(argv[2],"wan3_green")==0)
		{
			octeon_gpio_clr(2);
			octeon_gpio_set(4);
			printf("Turn on wan3_green led.\n");
		}
		else if(strcmp(argv[2],"wan3_amber")==0)
		{
			octeon_gpio_set(2);
			octeon_gpio_clr(4);
			printf("Turn on wan3_amber led.\n");
		}				
		else if(strcmp(argv[2],"wan4_green")==0)
		{
			octeon_gpio_clr(3);
			octeon_gpio_set(11);
			printf("Turn on wan4_green led.\n");
		}
		else if(strcmp(argv[2],"wan4_amber")==0)
		{
			octeon_gpio_set(3);
			octeon_gpio_clr(11);
			printf("Turn on wan4_amber led.\n");
		}						
		else if(strcmp(argv[2],"dmz")==0)
		{
			octeon_gpio_clr(16);
			printf("Turn on dmz led.\n");	
		}
		else if(strcmp(argv[2],"")==0)    /* turn on all leds*/
		{
			octeon_gpio_clr(13);

			octeon_gpio_clr(9);
			octeon_gpio_set(14);

			octeon_gpio_clr(10);
			octeon_gpio_set(15);

			octeon_gpio_clr(2);
			octeon_gpio_set(4);

			octeon_gpio_clr(3);
			octeon_gpio_set(11);
			
			octeon_gpio_clr(16);
			printf("Turn on all leds.\n");
		}
		else
		{
			printf("Invalid Parameter!\n");
			printf("ledtest on [test|wan1_green|wan1_amber|wan2_green|wan2_amber|wan3_green|wan3_amber|wan4_green|wan4_amber|dmz]\n");
		       return 1;
		}
		return 0;	
	}
	else
	{
		printf("wrong parameter!\n");
		printf("ledtest on [test|wan1_green|wan1_amber|wan2_green|wan2_amber|wan3_green|wan3_amber|wan4_green|wan4_amber|dmz]\n");
		printf("ledtest off [test|wan1|wan2|wan3|wan4|dmz]\n");
		return 1;
	}
	return 0;
}
/* Implemented in $(CPU)/interrupts.c */
#if (CONFIG_COMMANDS & CFG_CMD_IRQ)
int do_irqinfo (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[]);

U_BOOT_CMD(
	irqinfo,    1,    1,     do_irqinfo,
	"irqinfo - print information about IRQs\n",
	NULL
);
#endif  /* CONFIG_COMMANDS & CFG_CMD_IRQ */

U_BOOT_CMD(
	sleep ,    2,    2,     do_sleep,
	"sleep   - delay execution for some time\n",
	"N\n"
	"    - delay execution for N seconds (N is _decimal_ !!!)\n"
);

// add by Joe; GPIO SET
U_BOOT_CMD(
        wgpio,      2,     2,      Wgpio,
        "wgpio   - Set GPIO.\n",
        " \n"
        "\t wgpio [port num].\n"
);

// add by Joe; GPIO CLR
U_BOOT_CMD(
        cgpio,      2,     2,      Cgpio,
        "cgpio   - Clear GPIO.\n",
        " \n"
        "\t cgpio [port num].\n"
);

// add by Joe; GPIO READ
U_BOOT_CMD(
        rgpio,      2,     2,      Rgpio,
        "rgpio   - Read GPIO.\n",
        " \n"
        "\t rgpio [port num].\n"
);

// add by Joe; Test factory reset Button
U_BOOT_CMD(
        frtest,      1,     1,      test_reset_button_cmd,
        "frtest   - Test reset button.\n",
        " \n"
        "\t Press reset button then execute command.\n"
);


U_BOOT_CMD(
	ledtest ,    3,    3,     do_testled,
	"ledtest   - Turn on/off [test |wan1 |wan2 | dmz] LED\n",
	" \n"
	"\t ledtest on/off [test |wan1 |wan2 |dmz]\n"
);
U_BOOT_CMD(
        fantest,      1,     1,      test_fan_cmd,
        "fantest   - Test fan.\n",
        " \n"
        "\t Test fan then execute command.\n"
);
#endif	/* CFG_CMD_MISC */
