
#ifndef __OCTEON_NICPRO2_SHARED_H__
#define __OCTEON_NICPRO2_SHARED_H__


#define OCTEON_NICPRO2_EEPROM_ADDR  (0x53)

/* SPD EEPROM addresses on NICPRO2 board */
#define NICPRO2_DIMM_0_SPD_TWSI_ADDR    0x51
#define NICPRO2_DIMM_1_SPD_TWSI_ADDR    0x52
#define NICPRO2_DIMM_2_SPD_TWSI_ADDR	0x55
#define NICPRO2_DIMM_3_SPD_TWSI_ADDR	0x56

/* NIC Pro2 has two pair of DIMM sockets. DIMM 0 must be populated.
** Populating DIMM 1 enables the 128/144-bit interface.
*/
#define OCTEON_NICPRO2_DRAM_SOCKET_CONFIGURATION \
    {NICPRO2_DIMM_0_SPD_TWSI_ADDR, NICPRO2_DIMM_1_SPD_TWSI_ADDR}, \
    {NICPRO2_DIMM_2_SPD_TWSI_ADDR, NICPRO2_DIMM_3_SPD_TWSI_ADDR}


/*
** CN58xx Registered configuration
*/
#define OCTEON_CN58XX_NICPRO2_DDR_BOARD_DELAY		3900
#define OCTEON_CN58XX_NICPRO2_LMC_DELAY_CLK		2
#define OCTEON_CN58XX_NICPRO2_LMC_DELAY_CMD		0
#define OCTEON_CN58XX_NICPRO2_LMC_DELAY_DQ		3

/*
** CN58xx Unbuffered configuration
*/
#define OCTEON_CN58XX_NICPRO2_UNB_DDR_BOARD_DELAY	4000
#define OCTEON_CN58XX_NICPRO2_UNB_LMC_DELAY_CLK		12
#define OCTEON_CN58XX_NICPRO2_UNB_LMC_DELAY_CMD  	0
#define OCTEON_CN58XX_NICPRO2_UNB_LMC_DELAY_DQ		7

#endif /* __OCTEON_NICPRO2_SHARED_H__ */
